#!/usr/bin/env python3


"""                          _    _
                            | |  (_)
 _ __  _   _ _ __ ___  _ __ | | ___ _ __    _ __   __ _  ___ _ __ ___   __ _ _ __
| '_ \| | | | '_ ` _ \| '_ \| |/ / | '_ \  | '_ \ / _` |/ __| '_ ` _ \ / _` | '_ \
| |_) | |_| | | | | | | |_) |   <| | | | | | |_) | (_| | (__| | | | | | (_| | | | |
| .__/ \__,_|_| |_| |_| .__/|_|\_\_|_| |_| | .__/ \__,_|\___|_| |_| |_|\__,_|_| |_|
| |                   | |                  | |
|_|                   |_|                  |_|                                  """

# bron:
#    https://pythonprogramming.altervista.org/simple-labytinth-in-pygame/
#
# meer oefeningen:
#    https://www.w3resource.com/python-exercises/python-functions-exercises.php

__author__: "OPLOSSING"
__klas__: "<uw klas>"
__date__: "27/10/2023"


#________________________________________________________________________________
# Oefening 0: Voorbereiding
"""
- installeer "pygame" (via "pip")
- download de spelbibliotheek en twee beeldjes van de website:
    + https://mielke.ws/dat/pacman.py
    + https://mielke.ws/dat/pompoen.jpg
    + https://mielke.ws/dat/snoep.jpg
"""

from pacman import TheGame


#________________________________________________________________________________
# Oefening 1: Functies
"""
Pas de functie beneden zo aan
dat de pompoen (of: gele veld) op het snoepje (of: rode veld) belandt.
"""

def Oefening1():
    # hier wordt een eenvoudige schakbord-spelveld aangemaakt.
    level1 = [
        "WWWWWWW",
        "W   WEW",
        "W S W W",
        "W   W W",
        "W     W",
        "WWWWWWW",
       ]

    # hier wordt het spel geïnitialiseerd
    game = TheGame(level1, img_path = 'pompoen.jpg', snoep_img = 'snoep.jpg')
    player = game.player


    # hier is een demo-functie:
    #         [!] pas deze functie zo aan dat de pompoen zijn doel bereikt
    def MyTestFunction():
        # zet hier uw lijst van commando's
        player.MoveRight()
        player.MoveDown()
        player.MoveDown()
        player.MoveRight()
        player.MoveRight()
        for _ in range(3):
            player.MoveUp()
        #player.Wait()
        #player.MoveLeft()


    # En hier laten we de functie uitvoeren.
    game.RunFunction(MyTestFunction)

# Oefening1()

#________________________________________________________________________________
# Oefening 2: Nog een functie!
"""
... en hier nog een "level".
dat de pompoen (of: gele veld) op het snoepje (of: rode veld) belandt.
Deze keer moet u ook de initialisatie en "RunFunction" overnemen.
"""

def Oefening2():
    level2 = [
        "WWWWWWWWWWWWWWWWWWWW",
        "W     W            W",
        "W S   W            W",
        "W     W      W   E W",
        "W            W     W",
        "W            W     W",
        "WWWWWWWWWWWWWWWWWWWW",
       ]

    # U kan enkele delen van het programma van Oefening1() kopiëren
    game = TheGame(level2, img_path = 'pompoen.jpg', snoep_img = 'snoep.jpg')
    player = game.player


    # hier is de oplossing voor level 2:
    def MyTestFunction():
        # zet hier uw lijst van commando's
        player.MoveRight()
        player.MoveRight()
        player.MoveRight()
        player.MoveDown()
        player.MoveDown()
        player.MoveRight()
        player.MoveRight()
        player.MoveUp()
        player.MoveUp()
        for _ in range(10):
            player.MoveRight()
        player.MoveDown()


    # vergeet niet het spel te laten uitvoeren.
    game.RunFunction(MyTestFunction)

# Oefening2()

#________________________________________________________________________________
# Oefening 3: Meetingen
# a) bewegingsgeschiedenis
"""
Pas de functies boven aan zo dat ze de bewegingsgeschiedenis in een tekstcode of lijst terug geven (gebruik `return`),
bv. "^>.v<" voor "up, right, wait, down, left".
"""

weg = '>>>^'

def Oefening3(weg):
    # Ik zou altijd een heel simple level toepassen, dan gaat het foutvinden sneller...
    test_level = [
        "WWWWWW",
        "W   EW",
        "WS   W",
        "WWWWWW",
       ]

    # hier wordt het spel geïnitialiseerd
    game = TheGame(test_level)
    player = game.player

    def StorePath(path):
        # Deze functie geeft ook de loopweg van de pompoen weer.

        player.MoveRight()
        player.MoveRight()
        player.MoveRight()
        player.MoveUp()

        # ... maar dit is een heel simple manier om het te doen,
        # en ze kan gemakkelijk fout gaan: niets controlleerd dat
        # de weg boven met de return-string hier overeen komt
        return '>>>^'

    # Wij kunnen het omdraaien:
    # Maak er een functie die een weg in tekstvorm krijgt en uitvoerd.
    def GaDeWeg1(weg):
        # input: een string "weg"
        # bestaand uit de letters '<>^v.'.

        for letter in weg:
            if letter == '<':
                player.MoveLeft()
            elif letter == '>':
                player.MoveRight()
            elif letter == 'v':
                player.MoveDown()
            elif letter == '^':
                player.MoveUp()
            else:
                print(letter, 'is geen juiste commando! (ik skip het)')
                continue # springt na de volgende letter in de loop

    # game.RunFunction(GaDeWeg1, '>>>^')

    # Noot dat er boven vieere "elif/else" blokjes zijn;
    # dit is moeilijk te generaliseren als er nog meer lettercommando's
    # zouden bijkomen.
    # gelukkig maar kan je functies ook in een dict steken!

    # een dictionary met commando's
    commandos = { \
          '<': player.MoveLeft \
        , '>': player.MoveRight \
        , 'v': player.MoveDown \
        , '^': player.MoveUp \
        , '.': player.Wait \
        }

    def GaDeWeg2(weg):
        # input: een string "weg"
        # bestaand uit de letters '<>^v.'.
        for letter in weg:

            commandos[letter]()
            # noot de haakjes: we krijgen de functie terug, maar moeten ze nog
            # uitvoeren met "()"
            # dit is hetzelfde als:
            #   functie = commandos[letter]
            #   functie()

            # of nog beter:
            # commandos.get(letter, player.Wait)()

    game.RunFunction(GaDeWeg2, weg)

    # laat ons de weg terug geven om verder mee te rekenen.
    return weg

# Oefening3(weg)


# b) stappen tellen
"""
Maak er een functie aan die
 - een bewegingsgeschiedenis als input krijgt
 - de stappen telt en returnt!
"""
# "lambda"-functies zijn functies die we in één lijn kunnen defineren.
StappenTellen = lambda stappen: len(stappen)

print (StappenTellen(weg), 'stappen.')

# c) afstand meten
"""
Maak er een andere functie aan die de weg integreerd en het afstand van eind- en startpunt berekent.
Gebruik de Euclidse afstand: https://nl.wikipedia.org/wiki/Afstand_(wiskunde)#Tussen_twee_punten
"""
# we hebben numpy nodig
import numpy as np

def AfstandMeten(weg):
    # we moeten de commandos in afstanden omrekenen
    vectoren = { \
          '<': (-1,0) \
        , '>': (+1,0) \
        , 'v': (0,-1) \
        , '^': (0,1) \
        , '.': (0,0) \
        }

    # tellen we het op!
    # voor de x-afstand nemen we het nul'te element in de vector, en tellen op
    # voor de x-afstand nemen we het eerste element in de vector, en tellen op
    x_afstand = sum([vectoren[stap][0] for stap in weg])
    y_afstand = sum([vectoren[stap][1] for stap in weg])

    # Euclid sqrt(sum(x_i**2))
    afstand = np.sqrt(x_afstand**2 + y_afstand**2)

    # en die afstand gooien we dan terug.
    return afstand

print ('afstand:', AfstandMeten(weg))


#________________________________________________________________________________
# Oefening 3: The Real Pacman!!
"""
[Dit is helemaal een bonus-oefening voor wie er al zin in heeft.]

U kan dit programma al met de pijltjes bedienen met
    game.Run()
Opdracht: maak er een echte pacman van!
- ontwerp een boeiend labyrint
- zet er spookjes* in
- laat de spookjes* bewegen!

* hiervoor moet u de bibliotheek "pacman.py" aanpassen.

Succes!

"""
